;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_emitcode
  (foreign (include #"caml-bigloo.h"))
  (import
    (__caml_misc #"misc.scm")
    (__caml_buffcode #"buffcode.scm")
    (__caml_config #"config.scm")
    (__camli_config #"config.sci")
    (__caml_opcodes #"opcodes.scm")
    (__caml_reloc #"reloc.scm")
    (__caml_labels #"labels.scm")
    (__caml_instruct #"instruct.scm")
    (__caml_prim_opc #"prim_opc.scm")
    (__caml_globals #"globals.scm")
    (__caml_prim #"prim.scm")
    (__caml_const #"const.scm"))
  (export
    (out_bool_test_109@emitcode x1)
    (2-192-out_bool_test_109@emitcode x1 x2)
    (out_int_const_243@emitcode x1)
    (out_tag_245@emitcode x1)
    (out_header_98@emitcode x1)
    (size_of_dummy_91@emitcode x1)
    (emit_178@emitcode x1)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(begin
  (define out_bool_test_109@emitcode
    (lambda (x1)
      (lambda (x2)
        (2-192-out_bool_test_109@emitcode x1 x2))))
 (define 2-192-out_bool_test_109@emitcode
    (lambda (x1 x2)
      (labels
        ((staticfail1000
           ()
           (fatal_error_193@misc #"out_bool_test")))
        (let ((:-d.1001 x2))
          (cond ((eq? :-d.1001 (caml-make-tag 0 7))
                 (out_60@buffcode x1))
                ((eq? :-d.1001 (caml-make-tag 1 7))
                 (out_60@buffcode (+fx x1 1)))
                ((eq? :-d.1001 (caml-make-tag 3 7))
                 (out_60@buffcode (+fx x1 2)))
                ((eq? :-d.1001 (caml-make-tag 5 7))
                 (out_60@buffcode (+fx x1 3)))
                ((eq? :-d.1001 (caml-make-tag 4 7))
                 (out_60@buffcode (+fx x1 4)))
                ((eq? :-d.1001 (caml-make-tag 6 7))
                 (out_60@buffcode (+fx x1 5)))
                (else (staticfail1000)))))))
)
(define out_int_const_243@emitcode
  (lambda (x1)
    (if (and (<=fx x1 (/fx (-fx maxint_byte_178@config 1) 2))
             (>=fx x1 (/fx (-fx minint_byte_232@config 1) 2)))
      (begin
        (out_60@buffcode constbyte_220@opcodes)
        (out_60@buffcode (+fx (+fx x1 x1) 1)))
      (if (and (<=fx x1 (/fx (-fx maxint_short_71@config 1) 2))
               (>=fx x1 (/fx (-fx minint_short_93@config 1) 2)))
        (begin
          (out_60@buffcode constshort_186@opcodes)
          (out_short_156@buffcode (+fx (+fx x1 x1) 1)))
        (begin
          (out_60@buffcode getglobal_118@opcodes)
          (slot_for_literal_145@reloc
            (caml-make-regular
              (caml-make-tag 0 2)
              1
              (caml-make-regular (caml-make-tag 0 4) 1 x1))))))))

(define out_tag_245@emitcode
  (lambda (x1)
    (case (caml-regular-constr-tag x1)
      ((2)
       (out_60@buffcode (caml-constr-get-field x1 1)))
      (else
       ((slot_for_tag_19@reloc
          (caml-constr-get-field x1 0))
        (caml-constr-get-field x1 1))))))

(define out_header_98@emitcode
  (lambda (x1)
    (begin
      (out_tag_245@emitcode
        (caml-constr-get-field x1 1))
      (begin
        (out_60@buffcode
          (bit-lsh (caml-constr-get-field x1 0) 2))
        (begin
          (out_60@buffcode
            (bit-rsh (caml-constr-get-field x1 0) 6))
          (out_60@buffcode
            (bit-rsh (caml-constr-get-field x1 0) 14)))))))

(define size_of_dummy_91@emitcode
  (lambda (x1)
    (let ((:-d.1002 x1))
      (cond ((eq? :-d.1002 (caml-make-tag 2 7)) 2)
            ((eq? :-d.1002 (caml-make-tag 5 7)) 2)
            ((eq? :-d.1002 (caml-make-tag 6 7)) 2)
            (else
             (case (caml-regular-constr-tag :-d.1002)
               ((4 1) (caml-constr-get-field x1 0))
               ((2) (caml-constr-get-field x1 1))
               (else (caml-constr-get-field x1 0))))))))

(define emit_178@emitcode
  (lambda (x1)
    (if (null? x1)
      (caml-make-tag 0 1)
      (labels
        ((staticfail1003
           ()
           (begin
             (out_60@buffcode
               (let ((x2 (car x1)))
                 (labels
                   ((staticfail1004
                      ()
                      (fatal_error_193@misc #"emit: should not happen")))
                   (let ((:-d.1005 x2))
                     (cond ((eq? :-d.1005 (caml-make-tag 12 28))
                            return_226@opcodes)
                           ((eq? :-d.1005 (caml-make-tag 4 28))
                            grab_247@opcodes)
                           ((eq? :-d.1005 (caml-make-tag 5 28))
                            push_64@opcodes)
                           ((eq? :-d.1005 (caml-make-tag 6 28))
                            pushmark_205@opcodes)
                           ((eq? :-d.1005 (caml-make-tag 7 28))
                            let_213@opcodes)
                           ((eq? :-d.1005 (caml-make-tag 9 28))
                            apply_180@opcodes)
                           ((eq? :-d.1005 (caml-make-tag 10 28))
                            appterm_45@opcodes)
                           ((eq? :-d.1005 (caml-make-tag 18 28))
                            poptrap_163@opcodes)
                           ((eq? :-d.1005 (caml-make-tag 11 28))
                            check_signals_74@opcodes)
                           (else (staticfail1004)))))))
             (emit_178@emitcode (cdr x1)))))
        (let ((:-d.1006 (car x1)))
          (cond ((eq? :-d.1006 (caml-make-tag 5 28))
                 (if (null? (cdr x1))
                   (staticfail1003)
                   (case (if (caml-constant-constr? (car (cdr x1)))
                           -1
                           (caml-regular-constr-tag (car (cdr x1))))
                     ((2)
                      (if (null? (cdr (cdr x1)))
                        (staticfail1003)
                        (let ((:-d.1007 (car (cdr (cdr x1)))))
                          (cond ((eq? :-d.1007 (caml-make-tag 9 28))
                                 (begin
                                   (out_60@buffcode
                                     push_getglobal_apply_136@opcodes)
                                   (begin
                                     (slot_for_get_global_124@reloc
                                       (caml-constr-get-field (car (cdr x1)) 0))
                                     (emit_178@emitcode (cdr (cdr (cdr x1)))))))
                                ((eq? :-d.1007 (caml-make-tag 10 28))
                                 (begin
                                   (out_60@buffcode
                                     push_getglobal_appterm_156@opcodes)
                                   (begin
                                     (slot_for_get_global_124@reloc
                                       (caml-constr-get-field (car (cdr x1)) 0))
                                     (emit_178@emitcode (cdr (cdr (cdr x1)))))))
                                (else (staticfail1003))))))
                     (else (staticfail1003)))))
                (else
                 (case (if (caml-constant-constr? :-d.1006)
                         -1
                         (caml-regular-constr-tag :-d.1006))
                   ((1)
                    (labels
                      ((staticfail1008
                         ()
                         (begin
                           (out_60@buffcode getglobal_118@opcodes)
                           (begin
                             (slot_for_literal_145@reloc
                               (caml-constr-get-field (car x1) 0))
                             (emit_178@emitcode (cdr x1))))))
                      (case (caml-regular-constr-tag
                              (caml-constr-get-field (car x1) 0))
                        ((1)
                         (case (if (caml-constant-constr?
                                     (caml-constr-get-field
                                       (caml-constr-get-field (car x1) 0)
                                       0))
                                 -1
                                 (caml-regular-constr-tag
                                   (caml-constr-get-field
                                     (caml-constr-get-field (car x1) 0)
                                     0)))
                           ((1)
                            (begin
                              (out_int_const_243@emitcode
                                (caml-constr-get-field
                                  (caml-constr-get-field
                                    (caml-constr-get-field (car x1) 0)
                                    0)
                                  0))
                              (emit_178@emitcode (cdr x1))))
                           ((4)
                            (begin
                              (out_int_const_243@emitcode
                                (int_of_char
                                  (caml-constr-get-field
                                    (caml-constr-get-field
                                      (caml-constr-get-field (car x1) 0)
                                      0)
                                    0)))
                              (emit_178@emitcode (cdr x1))))
                           (else (staticfail1008))))
                        (else
                         (if (null? (caml-constr-get-field
                                      (caml-constr-get-field (car x1) 0)
                                      1))
                           (begin
                             (let ((x2 (caml-constr-get-field
                                         (caml-constr-get-field (car x1) 0)
                                         0)))
                               (case (caml-regular-constr-tag x2)
                                 ((2)
                                  (if (<fx (caml-constr-get-field x2 1) 10)
                                    (out_60@buffcode
                                      (+fx atom0_230@opcodes
                                           (caml-constr-get-field x2 1)))
                                    (begin
                                      (out_60@buffcode atom_224@opcodes)
                                      (out_60@buffcode
                                        (caml-constr-get-field x2 1)))))
                                 (else
                                  (begin
                                    (out_60@buffcode atom_224@opcodes)
                                    ((slot_for_tag_19@reloc
                                       (caml-constr-get-field x2 0))
                                     (caml-constr-get-field x2 1))))))
                             (emit_178@emitcode (cdr x1)))
                           (staticfail1008))))))
                   ((2)
                    (begin
                      (out_60@buffcode getglobal_118@opcodes)
                      (begin
                        (slot_for_get_global_124@reloc
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((3)
                    (begin
                      (out_60@buffcode setglobal_25@opcodes)
                      (begin
                        (slot_for_set_global_49@reloc
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((4)
                    (begin
                      (if (<fx (caml-constr-get-field (car x1) 0) 6)
                        (out_60@buffcode
                          (+fx acc0_19@opcodes
                               (caml-constr-get-field (car x1) 0)))
                        (begin
                          (out_60@buffcode access_239@opcodes)
                          (out_60@buffcode
                            (caml-constr-get-field (car x1) 0))))
                      (emit_178@emitcode (cdr x1))))
                   ((9)
                    (labels
                      ((staticfail1009
                         ()
                         (labels
                           ((staticfail1010
                              ()
                              (begin
                                (out_60@buffcode endlet_187@opcodes)
                                (begin
                                  (out_60@buffcode
                                    (caml-constr-get-field (car x1) 0))
                                  (emit_178@emitcode (cdr x1))))))
                           (let ((:-d.1011 (caml-constr-get-field (car x1) 0)))
                             (cond ((=fx :-d.1011 1)
                                    (begin
                                      (out_60@buffcode endlet1_105@opcodes)
                                      (emit_178@emitcode (cdr x1))))
                                   (else (staticfail1010)))))))
                      (if (null? (cdr x1))
                        (staticfail1009)
                        (case (if (caml-constant-constr? (car (cdr x1)))
                                -1
                                (caml-regular-constr-tag (car (cdr x1))))
                          ((9)
                           (emit_178@emitcode
                             (cons (caml-make-regular
                                     (caml-make-tag 8 28)
                                     1
                                     (+fx (caml-constr-get-field (car x1) 0)
                                          (caml-constr-get-field
                                            (car (cdr x1))
                                            0)))
                                   (cdr (cdr x1)))))
                          (else (staticfail1009))))))
                   ((15)
                    (begin
                      (out_60@buffcode letrec1_96@opcodes)
                      (begin
                        (out_label_131@labels
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((16)
                    (begin
                      (if (<=fx (caml-constr-get-field (car x1) 1) 0)
                        (fatal_error_193@misc #"emit : Kmakeblock")
                        (if (<fx (caml-constr-get-field (car x1) 1) 5)
                          (begin
                            (out_60@buffcode
                              (-fx (+fx makeblock1_239@opcodes
                                        (caml-constr-get-field (car x1) 1))
                                   1))
                            (out_tag_245@emitcode
                              (caml-constr-get-field (car x1) 0)))
                          (begin
                            (out_60@buffcode makeblock_160@opcodes)
                            (out_header_98@emitcode
                              (caml-make-regular
                                (caml-make-tag 0 1)
                                2
                                (caml-constr-get-field (car x1) 1)
                                (caml-constr-get-field (car x1) 0))))))
                      (emit_178@emitcode (cdr x1))))
                   ((20)
                    (if (eq? (caml-constr-get-field (car x1) 0)
                             nolabel_4@instruct)
                      (fatal_error_193@misc #"emit: undefined label")
                      (begin
                        (define_label_232@labels
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((14)
                    (begin
                      (out_60@buffcode cur_46@opcodes)
                      (begin
                        (out_label_131@labels
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((18)
                    (begin
                      (out_60@buffcode pushtrap_197@opcodes)
                      (begin
                        (out_label_131@labels
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((21)
                    (begin
                      (out_60@buffcode branch_151@opcodes)
                      (begin
                        (out_label_131@labels
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((24 22)
                    (begin
                      (out_60@buffcode branchif_3@opcodes)
                      (begin
                        (out_label_131@labels
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((25 23)
                    (begin
                      (out_60@buffcode branchifnot_240@opcodes)
                      (begin
                        (out_label_131@labels
                          (caml-constr-get-field (car x1) 0))
                        (emit_178@emitcode (cdr x1)))))
                   ((28)
                    (begin
                      (out_60@buffcode switch_61@opcodes)
                      (begin
                        (out_60@buffcode
                          (let ((:-d.1012 (caml-constr-get-field (car x1) 0)))
                            (if :-d.1012 (vector-length :-d.1012) 0)))
                        (let ((x2 (cell-ref out_position_239@buffcode)))
                          (begin
                            ((do_vect_153@fvect
                               (out_label_with_orig_230@labels x2))
                             (caml-constr-get-field (car x1) 0))
                            (emit_178@emitcode (cdr x1)))))))
                   ((26)
                    (begin
                      (let ((x2 (caml-constr-get-field (car x1) 0)))
                        (let ((:-d.1013 x2))
                          (cond ((eq? :-d.1013 (caml-make-tag 0 6))
                                 (begin
                                   (out_60@buffcode branchifeq_142@opcodes)
                                   (out_label_131@labels
                                     (caml-constr-get-field (car x1) 1))))
                                ((eq? :-d.1013 (caml-make-tag 1 6))
                                 (begin
                                   (out_60@buffcode branchifneq_7@opcodes)
                                   (out_label_131@labels
                                     (caml-constr-get-field (car x1) 1))))
                                (else
                                 (case (caml-regular-constr-tag :-d.1013)
                                   ((3)
                                    (labels
                                      ((staticfail1014
                                         ()
                                         (begin
                                           ((out_bool_test_109@emitcode
                                              branchifeq_142@opcodes)
                                            (caml-constr-get-field x2 0))
                                           (out_label_131@labels
                                             (caml-constr-get-field
                                               (car x1)
                                               1)))))
                                      (case (if (caml-constant-constr?
                                                  (caml-constr-get-field x2 0))
                                              -1
                                              (caml-regular-constr-tag
                                                (caml-constr-get-field x2 0)))
                                        ((3)
                                         (begin
                                           (out_60@buffcode push_64@opcodes)
                                           (begin
                                             (out_60@buffcode push_64@opcodes)
                                             (begin
                                               (out_int_const_243@emitcode
                                                 (caml-constr-get-field
                                                   (caml-constr-get-field x2 0)
                                                   0))
                                               (begin
                                                 (out_60@buffcode
                                                   eq_107@opcodes)
                                                 (begin
                                                   (out_60@buffcode
                                                     popbranchifnot_153@opcodes)
                                                   (out_label_131@labels
                                                     (caml-constr-get-field
                                                       (car x1)
                                                       1))))))))
                                        (else (staticfail1014)))))
                                   ((4)
                                    (labels
                                      ((staticfail1015
                                         ()
                                         (begin
                                           ((out_bool_test_109@emitcode
                                              eqfloat_61@opcodes)
                                            (caml-constr-get-field x2 0))
                                           (begin
                                             (out_60@buffcode
                                               branchif_3@opcodes)
                                             (out_label_131@labels
                                               (caml-constr-get-field
                                                 (car x1)
                                                 1))))))
                                      (case (if (caml-constant-constr?
                                                  (caml-constr-get-field x2 0))
                                              -1
                                              (caml-regular-constr-tag
                                                (caml-constr-get-field x2 0)))
                                        ((3)
                                         (begin
                                           (out_60@buffcode push_64@opcodes)
                                           (begin
                                             (out_60@buffcode push_64@opcodes)
                                             (begin
                                               (out_60@buffcode
                                                 getglobal_118@opcodes)
                                               (begin
                                                 (slot_for_literal_145@reloc
                                                   (caml-make-regular
                                                     (caml-make-tag 0 2)
                                                     1
                                                     (caml-make-regular
                                                       (caml-make-tag 1 4)
                                                       1
                                                       (caml-constr-get-field
                                                         (caml-constr-get-field
                                                           x2
                                                           0)
                                                         0))))
                                                 (begin
                                                   (out_60@buffcode
                                                     eqfloat_61@opcodes)
                                                   (begin
                                                     (out_60@buffcode
                                                       popbranchifnot_153@opcodes)
                                                     (out_label_131@labels
                                                       (caml-constr-get-field
                                                         (car x1)
                                                         1)))))))))
                                        (else (staticfail1015)))))
                                   ((5)
                                    (labels
                                      ((staticfail1016
                                         ()
                                         (begin
                                           ((out_bool_test_109@emitcode
                                              eqstring_56@opcodes)
                                            (caml-constr-get-field x2 0))
                                           (begin
                                             (out_60@buffcode
                                               branchif_3@opcodes)
                                             (out_label_131@labels
                                               (caml-constr-get-field
                                                 (car x1)
                                                 1))))))
                                      (case (if (caml-constant-constr?
                                                  (caml-constr-get-field x2 0))
                                              -1
                                              (caml-regular-constr-tag
                                                (caml-constr-get-field x2 0)))
                                        ((3)
                                         (begin
                                           (out_60@buffcode push_64@opcodes)
                                           (begin
                                             (out_60@buffcode push_64@opcodes)
                                             (begin
                                               (out_60@buffcode
                                                 getglobal_118@opcodes)
                                               (begin
                                                 (slot_for_literal_145@reloc
                                                   (caml-make-regular
                                                     (caml-make-tag 0 2)
                                                     1
                                                     (caml-make-regular
                                                       (caml-make-tag 2 4)
                                                       1
                                                       (caml-constr-get-field
                                                         (caml-constr-get-field
                                                           x2
                                                           0)
                                                         0))))
                                                 (begin
                                                   (out_60@buffcode
                                                     eqstring_56@opcodes)
                                                   (begin
                                                     (out_60@buffcode
                                                       popbranchifnot_153@opcodes)
                                                     (out_label_131@labels
                                                       (caml-constr-get-field
                                                         (car x1)
                                                         1)))))))))
                                        (else (staticfail1016)))))
                                   (else
                                    (begin
                                      (out_60@buffcode
                                        branchifneqtag_253@opcodes)
                                      (begin
                                        (out_tag_245@emitcode
                                          (caml-constr-get-field x2 0))
                                        (out_label_131@labels
                                          (caml-constr-get-field
                                            (car x1)
                                            1))))))))))
                      (emit_178@emitcode (cdr x1))))
                   ((27)
                    (begin
                      (out_60@buffcode push_64@opcodes)
                      (begin
                        (out_int_const_243@emitcode
                          (caml-constr-get-field (car x1) 0))
                        (begin
                          (out_60@buffcode push_64@opcodes)
                          (begin
                            (if ((lambda (x y) (not (eq? x y)))
                                 (caml-constr-get-field (car x1) 0)
                                 (caml-constr-get-field (car x1) 1))
                              (out_int_const_243@emitcode
                                (caml-constr-get-field (car x1) 1))
                              (caml-make-tag 0 1))
                            (begin
                              (out_60@buffcode branchinterval_39@opcodes)
                              (begin
                                (out_label_131@labels
                                  (caml-constr-get-field (car x1) 2))
                                (begin
                                  (out_label_131@labels
                                    (caml-constr-get-field (car x1) 3))
                                  (emit_178@emitcode (cdr x1))))))))))
                   ((17)
                    (labels
                      ((staticfail1017
                         ()
                         (begin
                           (let ((x2 (caml-constr-get-field (car x1) 0)))
                             (labels
                               ((staticfail1018
                                  ()
                                  (out_60@buffcode
                                    (opcode_for_primitive_27@prim_opc x2))))
                               (case (if (caml-constant-constr? x2)
                                       -1
                                       (caml-regular-constr-tag x2))
                                 ((4)
                                  (begin
                                    (out_60@buffcode dummy_118@opcodes)
                                    (out_60@buffcode
                                      (size_of_dummy_91@emitcode
                                        (caml-constr-get-field x2 0)))))
                                 ((6)
                                  (let ((x3 (caml-constr-get-field x2 0)))
                                    (labels
                                      ((staticfail1019
                                         ()
                                         (fatal_error_193@misc
                                           #"emit : Kprim, Ptest")))
                                      (let ((:-d.1020 x3))
                                        (cond ((eq? :-d.1020
                                                    (caml-make-tag 0 6))
                                               (out_60@buffcode eq_107@opcodes))
                                              ((eq? :-d.1020
                                                    (caml-make-tag 1 6))
                                               (out_60@buffcode
                                                 neq_145@opcodes))
                                              (else
                                               (case (if (caml-constant-constr?
                                                           :-d.1020)
                                                       -1
                                                       (caml-regular-constr-tag
                                                         :-d.1020))
                                                 ((3)
                                                  ((out_bool_test_109@emitcode
                                                     eq_107@opcodes)
                                                   (caml-constr-get-field
                                                     x3
                                                     0)))
                                                 ((4)
                                                  ((out_bool_test_109@emitcode
                                                     eqfloat_61@opcodes)
                                                   (caml-constr-get-field
                                                     x3
                                                     0)))
                                                 ((5)
                                                  ((out_bool_test_109@emitcode
                                                     eqstring_56@opcodes)
                                                   (caml-constr-get-field
                                                     x3
                                                     0)))
                                                 (else (staticfail1019)))))))))
                                 ((9)
                                  (if (<fx (caml-constr-get-field x2 0) 4)
                                    (out_60@buffcode
                                      (+fx getfield0_7@opcodes
                                           (caml-constr-get-field x2 0)))
                                    (begin
                                      (out_60@buffcode getfield_41@opcodes)
                                      (out_60@buffcode
                                        (caml-constr-get-field x2 0)))))
                                 ((10)
                                  (if (<fx (caml-constr-get-field x2 0) 4)
                                    (out_60@buffcode
                                      (+fx setfield0_207@opcodes
                                           (caml-constr-get-field x2 0)))
                                    (begin
                                      (out_60@buffcode setfield_155@opcodes)
                                      (out_60@buffcode
                                        (caml-constr-get-field x2 0)))))
                                 ((11)
                                  (begin
                                    (if (<=fx (caml-constr-get-field x2 1) 5)
                                      (out_60@buffcode
                                        (-fx (+fx c_call1_170@opcodes
                                                  (caml-constr-get-field x2 1))
                                             1))
                                      (begin
                                        (out_60@buffcode c_calln_100@opcodes)
                                        (out_60@buffcode
                                          (caml-constr-get-field x2 1))))
                                    (slot_for_c_prim_55@reloc
                                      (caml-constr-get-field x2 0))))
                                 ((31)
                                  (begin
                                    (out_60@buffcode floatop_120@opcodes)
                                    (out_60@buffcode
                                      (opcode_for_float_primitive_146@prim_opc
                                        (caml-constr-get-field x2 0)))))
                                 (else (staticfail1018)))))
                           (emit_178@emitcode (cdr x1)))))
                      (let ((:-d.1021 (caml-constr-get-field (car x1) 0)))
                        (cond ((eq? :-d.1021 (caml-make-tag 0 38))
                               (emit_178@emitcode (cdr x1)))
                              (else (staticfail1017))))))
                   (else (staticfail1003))))))))))

